import abc
from _typeshed import Incomplete
from datasurface.md import Documentation as Documentation
from datasurface.md.Governance import CloudVendor as CloudVendor, DataContainer as DataContainer, DataPlatform as DataPlatform, Ecosystem as Ecosystem, InfrastructureLocation as InfrastructureLocation, InfrastructureVendor as InfrastructureVendor, ObjectStorage as ObjectStorage
from datasurface.md.Lint import ValidationTree as ValidationTree
from typing import Optional

class AmazonAWSDataPlatform(DataPlatform):
    def __init__(self, name: str, doc: Documentation) -> None: ...
    def getSupportedVendors(self, eco: Ecosystem) -> set[InfrastructureVendor]: ...
    def __hash__(self) -> int: ...
    def __eq__(self, __value: object) -> bool: ...
    def isContainerSupported(self, eco: Ecosystem, dc: DataContainer) -> bool: ...
    def lint(self, eco: Ecosystem, tree: ValidationTree): ...
    def getInternalDataContainers(self) -> set[DataContainer]: ...

class AmazonAWSS3Bucket(ObjectStorage, metaclass=abc.ABCMeta):
    def __init__(self, name: str, loc: InfrastructureLocation, endPointURI: Optional[str], bucketName: str, prefix: Optional[str]) -> None: ...
    def __eq__(self, o: object) -> bool: ...
    def __hash__(self) -> int: ...

class AmazonAWSKinesis(DataContainer, metaclass=abc.ABCMeta):
    endPointURI: Incomplete
    def __init__(self, name: str, loc: InfrastructureLocation, endPointURI: Optional[str]) -> None: ...
    def __eq__(self, o: object) -> bool: ...
    def __hash__(self) -> int: ...

class AmazonAWSDynamoDB(DataContainer, metaclass=abc.ABCMeta):
    endPointURI: Incomplete
    def __init__(self, name: str, loc: InfrastructureLocation, endPointURI: Optional[str]) -> None: ...
    def __eq__(self, o: object) -> bool: ...
    def __hash__(self) -> int: ...

class AmazonAWSSQS(DataContainer, metaclass=abc.ABCMeta):
    queueURL: Incomplete
    def __init__(self, name: str, loc: InfrastructureLocation, queueURL: Optional[str]) -> None: ...
    def __eq__(self, o: object) -> bool: ...
    def __hash__(self) -> int: ...
