from _typeshed import Incomplete
from enum import Enum
from typing import Any

class ProblemSeverity(Enum):
    ERROR: int
    WARNING: int
    INFO: int

class ValidationProblem:
    description: Incomplete
    sev: Incomplete
    def __init__(self, desc: str, sev: ProblemSeverity = ...) -> None: ...
    def __eq__(self, o: object) -> bool: ...

class UnknownObjectReference(ValidationProblem):
    def __init__(self, obj: object, sev: ProblemSeverity) -> None: ...

class AttributeNotSet(ValidationProblem):
    def __init__(self, key: str) -> None: ...

class ObjectIsDeprecated(ValidationProblem):
    def __init__(self, obj: object, sev: ProblemSeverity) -> None: ...

class DataTransformerMissing(ValidationProblem):
    def __init__(self, obj: object, sev: ProblemSeverity) -> None: ...

class ObjectWrongType(ValidationProblem):
    def __init__(self, obj: object, expectedType: type, sev: ProblemSeverity) -> None: ...

class ObjectMissing(ValidationProblem):
    def __init__(self, container: object, missingObject: object, sev: ProblemSeverity) -> None: ...

class UnauthorizedAttributeChange(ValidationProblem):
    def __init__(self, attribute: str, obj1: object, obj2: object, sev: ProblemSeverity) -> None: ...

class NameMustBeSQLIdentifier(ValidationProblem):
    def __init__(self, name: str, sev: ProblemSeverity) -> None: ...

class ObjectNotCompatibleWithPolicy(ValidationProblem):
    def __init__(self, obj: object, policy: object, sev: ProblemSeverity) -> None: ...

class DuplicateObject(ValidationProblem):
    def __init__(self, obj: object, sev: ProblemSeverity) -> None: ...

class ConstraintViolation(ValidationProblem):
    def __init__(self, obj: object, sev: ProblemSeverity) -> None: ...

class ProductionDatastoreMustHaveClassifications(ValidationProblem):
    def __init__(self, store: object, dataset: object) -> None: ...

class ValidationTree:
    object: Incomplete
    children: Incomplete
    problems: Incomplete
    def __init__(self, obj: object) -> None: ...
    def createChild(self, obj: object) -> ValidationTree: ...
    def getProblems(self) -> list[ValidationProblem]: ...
    def addProblem(self, problem: str, sev: ProblemSeverity = ...) -> None: ...
    def addRaw(self, problem: ValidationProblem) -> None: ...
    def hasErrors(self) -> bool: ...
    def hasIssues(self) -> bool: ...
    def checkTypeMatches(self, obj: object, *expectedType: type) -> bool: ...
    def printTree(self, indent: int = 0) -> None: ...
    def containsProblemType(self, type: Any) -> bool: ...
